## kmymoney 5.0.8

=== CMakeLists.txt ===
# The CMake version we require
cmake_minimum_required(VERSION 3.1)

# Setting the name of the main project
project(KMyMoney VERSION "5.0.8" LANGUAGES CXX)

# Determine the GIT reference (if we're based on GIT)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND git rev-parse --short HEAD WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" OUTPUT_VARIABLE VERSION_SUFFIX OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(VERSION_SUFFIX "-${VERSION_SUFFIX}")
  # Add variables which are similar to the build in names of cmake
  set(PROJECT_VERSION_SUFFIX "${VERSION_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "${VERSION_SUFFIX}")
elseif(DEFINED VERSION_SUFFIX)
  string(REGEX REPLACE "-*(.+)" "\\1" DASHFREE_SUFFIX "${VERSION_SUFFIX}")
  set(PROJECT_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
  set(${PROJECT_NAME}_VERSION_SUFFIX "-${DASHFREE_SUFFIX}")
endif()

# Automoc all sources
set(CMAKE_AUTOMOC TRUE)
list(APPEND CMAKE_AUTOMOC_MACRO_NAMES "K_PLUGIN_FACTORY" "K_PLUGIN_FACTORY_WITH_JSON")

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW) # Policy introduced in CMake version 3.3
endif()
if (POLICY CMP0071)
  # We do not require the old behaviour. It is only set to old, to prevent accidential use of
  # the new behavour. If the new behaviour becomes important, cmake_minimum_required has to be
  # set to "3.10".
  cmake_policy(SET CMP0071 OLD) # Policy introduced in CMake version 3.10
endif()


######################### General Requirements ##########################

if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0)
    message(FATAL_ERROR "This version of KMyMoney requires at least gcc 6.0.0 to be built successfully")
endif()

find_package(ECM 5.10 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(KDEInstallDirs)
include(KDECMakeSettings)
# reimplementation because kmymoney app image is bound to ECM 5.36
if("${ECM_GLOBAL_FIND_VERSION}" VERSION_LESS "5.38.0")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
  if(WIN32)
     set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
  else()
     set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
  endif()
elseif(NOT WIN32)
   set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
endif()

include(FeatureSummary)
include(CMakeDependentOption)

include(GenerateExportHeader)
include(KMyMoneyMacros)

find_package(PkgConfig)

set (OPT_KF5_COMPONENTS DocTools Holidays Contacts Akonadi IdentityManagement Activities)
find_package(Gpgmepp)
if (Gpgmepp_FOUND)
  set(GPG_ENCRYPTION ON)
else()
  set(GPG_ENCRYPTION OFF)
  list(APPEND OPT_KF5_COMPONENTS Gpgmepp)
endif()

if (PkgConfig_FOUND)
  pkg_check_modules(SQLCIPHER sqlcipher)
endif()

find_package(Qt5 5.6 REQUIRED
  COMPONENTS Core DBus Widgets Svg Xml Test PrintSupport
  OPTIONAL_COMPONENTS Sql Concurrent QuickWidgets)

find_package(KF5 5.2 REQUIRED
  COMPONENTS Archive CoreAddons Config ConfigWidgets I18n Completion KCMUtils ItemModels ItemViews Service Wallet IconThemes XmlGui TextWidgets Notifications KIO
  OPTIONAL_COMPONENTS ${OPT_KF5_COMPONENTS}
)

if(LibAlkimia5_DIR)
  set(_LibAlkimia5_DIR ${LibAlkimia5_DIR})
endif()
find_package(LibAlkimia5 8.0)
if (NOT LibAlkimia5_FOUND)
  # restore LibAlkimia5_DIR set to NOTFOUND by first find_package call
  if(_LibAlkimia5_DIR)
    set(LibAlkimia5_DIR ${_LibAlkimia5_DIR})
  endif()
  find_package(LibAlkimia5 7.0 REQUIRED)
endif()
# Recent changes to LibAlkimia should allow us to remove this construct
#if(CMAKE_SYSTEM_NAME MATCHES "Windows")
#  include_directories(${GMP_INCLUDE_DIR})
#endif()

find_package(KChart 2.6.0 REQUIRED)

if(KF5Gpgmepp_FOUND)
  set(GPG_ENCRYPTION ON)
  add_definitions(-DGpgmepp_FOUND)
endif()

add_feature_info("Encryption" GPG_ENCRYPTION "It allows encrypting your financial data.")

add_definitions(-DQT_USE_QSTRINGBUILDER -DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# use DBus only on Linux
if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(KMM_DBUS 1)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

# check for Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
  set(APIDOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/apidocs)

  make_directory("${APIDOC_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kmymoney.doxygen.in ${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen IMMEDIATE)

  add_custom_target(apidoc "${DOXYGEN}" "${CMAKE_CURRENT_BINARY_DIR}/kmymoney.doxygen")
endif(DOXYGEN_FOUND)
add_feature_info("Doxygen" DOXYGEN_FOUND "Generate API documentation with Doxygen (for devs only).")

# check some include files exists
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=500 -D_BSD_SOURCE)
include (CheckIncludeFileCXX)
check_include_file_cxx("unistd.h" HAVE_UNISTD_H)
check_include_file_cxx("pwd.h" HAVE_PWD_H)
check_include_file_cxx("windows.h" HAVE_WINDOWS_H)
check_include_file_cxx("lmcons.h" HAVE_LMCONS_H)
check_include_file_cxx("process.h" HAVE_PROCESS_H)

# include check for members in structs
include (CheckStructHasMember)

######################### Special Requirements ##########################

# This is needed for QtSqlite and QtDesigner
# (they'll install files to ${QT_INSTALL_DIR}/plugins/)
get_filename_component(QT_BIN_DIR "${QT_MOC_EXECUTABLE}" PATH)
get_filename_component(QT_DIR     ${QT_BIN_DIR}        PATH)
set(QT_INSTALL_DIR ${QT_DIR} CACHE PATH
  "Qt install prefix defaults to the Qt prefix: ${QT_DIR}")

if(KF5IdentityManagement_FOUND AND KF5Akonadi_FOUND AND KF5Contacts_FOUND)
  set(KMM_ADDRESSBOOK_FOUND true)
endif()

add_feature_info("Address book" KMM_ADDRESSBOOK_FOUND "It allows fetching payee information from KDE PIM system.")
add_feature_info("Holidays" KF5Holidays_FOUND "It allows fetching holidays from KDE PIM system.")

option(ENABLE_FORECASTVIEW "Enable forecast view" ON)
add_feature_info("Forecast view" ENABLE_FORECASTVIEW "It adds possibility to calculate forecasts.")
option(ENABLE_REPORTSVIEW "Enable reports view" ON)
add_feature_info("Reports view" ENABLE_REPORTSVIEW "It adds possibility to display chart and table reports.")
option(ENABLE_BUDGETVIEW "Enable budget view" ON)
add_feature_info("Budget view" ENABLE_BUDGETVIEW "It adds possibility to plan a budget.")
option(ENABLE_ONLINEJOBOUTBOXVIEW "Enable online job outbox view" ON)
add_feature_info("Online job outbox view" ENABLE_ONLINEJOBOUTBOXVIEW "It adds outbox for sending online jobs.")

cmake_dependent_option(ENABLE_SQLSTORAGE "Enable SQL storage support." ON
                       "Qt5Sql_FOUND" OFF)

add_feature_info("SQL Storage" ENABLE_SQLSTORAGE "It allows storing your financial data in SQL database.")

cmake_dependent_option(ENABLE_SQLCIPHER "Enable SQLCipher support." ON
                       "SQLCIPHER_FOUND" OFF)

# Otherwise compilers halt on something like that:
# ld: library not found for -lsqlcipher
# on MS Windows, FreeBSD, and macOS.
if(ENABLE_SQLCIPHER AND (NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_VERSION VERSION_LESS 3.5.2))
  link_directories(${SQLCIPHER_LIBRARY_DIRS})
endif()

add_feature_info("SQLCipher" ENABLE_SQLCIPHER "It allows encrypting your SQLite3 database.")

cmake_dependent_option(ENABLE_IBANBICDATA "Enable IBAN/BIC data support." OFF
                       "Qt5Sql_FOUND" OFF)

add_feature_info("IBAN/BIC data" ENABLE_IBANBICDATA "Adds predefined IBAN/BIC numbers to KMyMoney (note: doesn't work yet).")

# check for optional QWebEngine
option(ENABLE_WEBENGINE "Enable QWebEngine" OFF)
if(ENABLE_WEBENGINE)
  find_package(Qt5WebEngineWidgets 5.8 REQUIRED)
  if(Qt5WebEngineWidgets_VERSION VERSION_GREATER 5.8.99 AND Qt5WebEngineWidgets_VERSION VERSION_LESS 5.9.3)
    message(WARNING "QWebEngine version ${Qt5WebEngineWidgets_VERSION} is known to be unstable with KMyMoney")
  endif()
else(ENABLE_WEBENGINE)
  find_package(KF5WebKit REQUIRED)
endif(ENABLE_WEBENGINE)

# check for optional LibOFX support
find_package(LibOfx)
cmake_dependent_option(ENABLE_OFXIMPORTER "Enable OFX Importer" ON
                       "LIBOFX_FOUND" OFF)

if(ENABLE_OFXIMPORTER)
  if(NOT LIBOFX_HAVE_CLIENTUID)
    set(PATH_TO_LIBOFX_HEADER "${LIBOFX_INCLUDE_DIR}/libofx/libofx.h")
    unset(LIBOFX_HAVE_CLIENTUID)
    unset(LIBOFX_HAVE_CLIENTUID CACHE) #not doing this will prevent updating below check
    check_struct_has_member("struct OfxFiLogin" clientuid ${PATH_TO_LIBOFX_HEADER} LIBOFX_HAVE_CLIENTUID LANGUAGE CXX)
  endif()

  if (LIBOFX_HAVE_CLIENTUID)
    set (nice_LIBOFX_HAVE_CLIENTUID "yes")
  else()
    set (nice_LIBOFX_HAVE_CLIENTUID "no")
  endif()

else()
  set (nice_LIBOFX_HAVE_CLIENTUID "unknown")
  unset(LIBOFX_HAVE_CLIENTUID)
  unset(LIBOFX_HAVE_CLIENTUID CACHE)
endif(ENABLE_OFXIMPORTER)

add_feature_info("OFX Importer" ENABLE_OFXIMPORTER "It allows importing OFX files (have client uid version: ${nice_LIBOFX_HAVE_CLIENTUID})" )

# check for optional KBanking support
find_package(aqbanking 6.0.1)
find_package(gwenhywfar 5.1.2)
find_package(gwengui-cpp)
find_package(gwengui-qt5)

cmake_dependent_option(ENABLE_KBANKING "Enable KBanking plugin" ON
                       "AQBANKING_FOUND;gwengui-cpp_FOUND;gwengui-qt5_FOUND;Qt5QuickWidgets_FOUND" OFF)

add_feature_info(KBanking ENABLE_KBANKING "Interface for the following online banking protocols: HBCI, EBICS, OFX Direct Connect, Paypal")

# check for optional Weboob support
set(Python_ADDITIONAL_VERSIONS 2.7 2.6)
find_package(PythonInterp 2.6)
find_package(PythonLibs ${PYTHON_VERSION_STRING})

if(PYTHONINTERP_FOUND AND PYTHONLIBS_FOUND)
  if(NOT PYTHON_VERSION_MAJOR VERSION_LESS 3)
    unset(PYTHONLIBS_FOUND)
    unset(PYTHONINTERP_FOUND)
    message(WARNING "Python 2 required, but Python 3 found.")
  else()
    include(FindPythonModule)
    find_python_module(weboob REQUIRED)
  endif()
endif()

cmake_dependent_option(ENABLE_WEBOOB "Enable Weboob plugin" ON
                       "PYTHONLIBS_FOUND;PYTHONINTERP_FOUND;PY_WEBOOB;Qt5Concurrent_FOUND" OFF)
add_feature_info(Weboob ENABLE_WEBOOB "Online banking interface using Weboob.")


# check for optional ical support
find_package(Libical)
cmake_dependent_option(ENABLE_LIBICAL "Enable Calendar plugin" ON
                       "LIBICAL_FOUND" OFF)
add_feature_info(iCalendar ENABLE_LIBICAL "iCalendar integration.")


option(ENABLE_QIFIMPORTER "Enable QIF Importer" ON)
option(ENABLE_QIFEXPORTER "Enable QIF Exporter" ON)
add_feature_info("QIF Importer" ENABLE_QIFIMPORTER "It allows importing QIF files.")
add_feature_info("QIF Exporter" ENABLE_QIFEXPORTER "It allows exporting QIF files.")

option(ENABLE_GNCIMPORTER "Enable GNC Importer" ON)
add_feature_info("GNC Importer" ENABLE_GNCIMPORTER "It allows importing GNUCash files.")

option(ENABLE_CSVIMPORTER "Enable CSV Importer" ON)
option(ENABLE_CSVEXPORTER "Enable CSV Exporter" ON)
add_feature_info("CSV Importer" ENABLE_CSVIMPORTER "It allows importing CSV files.")
add_feature_info("CSV Exporter" ENABLE_CSVEXPORTER "It allows exporting CSV files.")

option(ENABLE_UNFINISHEDFEATURES "For devs only" OFF)

# TODO: this should be removed
enable_testing()

######################### Settings ##########################

# If no build type is set, use "Release with Debug Info"
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif(NOT CMAKE_BUILD_TYPE)

set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
  "Choose the type of build.
Possible values are: 'Release' 'RelWithDebInfo' 'Debug' 'DebugKMM' 'Debugfull' 'Profile'
The default value is: 'RelWithDebInfo'" FORCE)

# tells gcc to enable exception handling
include(KDECompilerSettings)
kde_enable_exceptions()

# Set linker flags

# There is no way to detect linker in cmake (see https://gitlab.kitware.com/cmake/cmake/issues/17596)
# and linkers aren't compatible with each other, so we need to assume something

=== kmymoney/CMakeLists.txt ===
include(ECMAddAppIcon)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/settings/
                    ${CMAKE_CURRENT_BINARY_DIR}/settings/
                    ${CMAKE_CURRENT_BINARY_DIR}/dialogs/
                    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/
                    ${CMAKE_CURRENT_BINARY_DIR}/widgets/
                    ${CMAKE_CURRENT_SOURCE_DIR}/mymoney/
                    ${CMAKE_CURRENT_SOURCE_DIR}/mymoney/storage/
                    ${CMAKE_CURRENT_SOURCE_DIR}/plugins/
                    ${CMAKE_CURRENT_BINARY_DIR}/plugins/
                    ${CMAKE_CURRENT_SOURCE_DIR}/views/
                    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/
                    ${CMAKE_CURRENT_SOURCE_DIR}/converter/
                    ${CMAKE_CURRENT_BINARY_DIR}/dialogs/settings/
                    ${CMAKE_CURRENT_BINARY_DIR}/mymoney/storage/
                    ${CMAKE_CURRENT_BINARY_DIR}/mymoney/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/endingbalancedlg/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/endingbalancedlg/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/newinvestmentwizard/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/newinvestmentwizard/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/newloanwizard/
                    ${CMAKE_CURRENT_BINARY_DIR}/wizards/newloanwizard/
                    ${CMAKE_CURRENT_SOURCE_DIR}/wizards/wizardpages/
                    ${CMAKE_CURRENT_SOURCE_DIR}/models/
                    ${CMAKE_CURRENT_BINARY_DIR}/models/
                    ${CMAKE_CURRENT_SOURCE_DIR}/icons/
                    ${CMAKE_CURRENT_BINARY_DIR}/icons/
                    ${CMAKE_CURRENT_SOURCE_DIR}/menus/
                    ${CMAKE_CURRENT_BINARY_DIR}/menus/
                    ${CMAKE_CURRENT_SOURCE_DIR}/misc/
                    ${CMAKE_CURRENT_BINARY_DIR}/misc/
                    )

add_subdirectory( mymoney )
add_subdirectory( settings )
add_subdirectory( models  )
add_subdirectory( plugins )
add_subdirectory( widgets )
add_subdirectory( dialogs )
add_subdirectory( views )
add_subdirectory( converter )
add_subdirectory( wizards )
add_subdirectory( pics )
add_subdirectory( html )
add_subdirectory( templates )
add_subdirectory( misc )
add_subdirectory( icons )
add_subdirectory( menus )
if(BUILD_TESTING)
  add_subdirectory( tests )
endif()

set( _HEADERS kmymoneyutils.h )

########### common code (kmymoney_common) STATIC ###############
# will be linked into kmymoney, kmymoneytest, and libkmymoney.so

set( kmymoney_common_SRCS kmymoneyutils.cpp kstartuplogo.cpp kcreditswindow.cpp )
add_library(kmymoney_common STATIC ${kmymoney_common_SRCS})

target_link_libraries(kmymoney_common
  PUBLIC
    Qt5::Core
    KF5::ConfigGui
    KF5::WidgetsAddons
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::KIONTLM
    Alkimia::alkimia
    kmm_mymoney
    kmm_utils_webconnect
    kmm_utils_platformtools
    PRIVATE
    KF5::I18n
    kmm_settings
)

# must build kmymoney/transactionsortoption.h
# from transactionsortoption.ui first
add_dependencies(kmymoney_common generate_base_ui_srcs kmm_settings)
add_dependencies(wizardpages widgets)
add_dependencies(dialogs widgets)

if(USE_MODELTEST)
  set( kmymoney_common_LIBS ${kmymoney_common_LIBS} ${QT_QTTEST_LIBRARY})
endif(USE_MODELTEST)

# remove these generated files, they are in the way and leftovers from 5.0
if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/kmymoneysettings.h)
  file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/kmymoneysettings.h)
endif()
if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/kmymoneysettings.cpp)
  file(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/kmymoneysettings.cpp)
endif()

########### kmymoney executable ###############

set( kmymoney_SRCS
  main.cpp
  kmymoney.cpp
  pluginloader.cpp
)

qt5_add_dbus_adaptor(kmymoney_SRCS org.kde.kmymoney.xml kmymoney.h KMyMoneyApp)
qt5_add_resources(kmymoney_SRCS kmymoney.qrc)

# collect application icons
file(GLOB_RECURSE KMYMONEY_APP_ICONS "${CMAKE_CURRENT_SOURCE_DIR}/icons/kmymoney/apps/*.png")
# add icons to application sources, to have them bundled
ecm_add_app_icon(kmymoney_SRCS ICONS ${KMYMONEY_APP_ICONS})

add_executable( kmymoney ${kmymoney_SRCS} )

if (ENABLE_SQLCIPHER)
  message( STATUS "     SQLCIPHER INCLUDE   :  " ${SQLCIPHER_INCLUDE_DIRS}) #just for testing it on MS Windows

  target_compile_definitions(kmymoney
    PRIVATE
      SQLITE_HAS_CODEC
      SQLITE_TEMP_STORE=2)

  #otherwise "fatal error: 'sqlite3.h' file not found"
  if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR CMAKE_SYSTEM_NAME MATCHES "Windows")
    target_include_directories(kmymoney
      PRIVATE
        ${SQLCIPHER_INCLUDE_DIRS})
  endif()
endif()

target_link_libraries(kmymoney
  PUBLIC
  views
  kmymoney_base
  kmymoney_common
  newuserwizard
  newaccountwizard
  newinvestmentwizard
  newloanwizard
  endingbalancedlg
  wizardpages
  dialogs
  widgets
  settings
  converter
  kmm_models
  kmm_settings
  kmm_menus
  kmm_widgets
  kmm_mymoney
  interfaces
  kmm_plugin
  Qt5::Core
  KF5::Archive
  KF5::ConfigGui
  KF5::WidgetsAddons
  KF5::KIOCore
  KF5::CoreAddons
  KChart
  $<$<BOOL:${USE_MODELTEST}>:Qt5::Test>
  $<$<BOOL:${KF5Holidays_FOUND}>:KF5::Holidays>
  $<$<BOOL:${KF5Activities_FOUND}>:KF5::Activities>
  PRIVATE
    $<$<BOOL:${ENABLE_SQLCIPHER}>:sqlcipher>
)

# create symlink to let kcoreaddons find plugins
if(WIN32 AND NOT CMAKE_CROSSCOMPILING)
  add_custom_command(TARGET kmymoney POST_BUILD
    COMMAND mklink /J kmymoney .
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
else()
  add_custom_command(TARGET kmymoney POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E create_symlink . kmymoney
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
endif()

# own plist magic for mac os
if(APPLE)
    # own plist template
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in)

    # the MacOSX bundle display name property (CFBundleDisplayName) is not currently supported by cmake,
    # so has to be set for all targets in this cmake file
    set(MACOSX_BUNDLE_DISPLAY_NAME KMyMoney)
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_DISPLAY_NAME "KMyMoney")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_INFO_STRING "KMyMoney - Personal Finances Manager")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "KMyMoney ${KDE_APPLICATIONS_VERSION}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDE_APPLICATIONS_VERSION_MAJOR}.${KDE_APPLICATIONS_VERSION_MINOR}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_BUNDLE_VERSION "${KDE_APPLICATIONS_VERSION}")
    set_target_properties(kmymoney PROPERTIES MACOSX_BUNDLE_COPYRIGHT "2000-2016 The KMyMoney Authors")
endif()

########### install files ###############

install(TARGETS kmymoney ${INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES ${_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney
  )
install(FILES org.kde.kmymoney.desktop
  DESTINATION ${XDG_APPS_INSTALL_DIR}
  )
install(FILES org.kde.kmymoney.appdata.xml
  DESTINATION ${KDE_INSTALL_METAINFODIR}
  )

install(FILES x-kmymoney.xml
  DESTINATION ${XDG_MIME_INSTALL_DIR})

install(FILES
   tips
   DESTINATION ${CMAKE_INSTALL_DATADIR}/kmymoney)

#UPDATE_XDG_MIMETYPES(${XDG_MIME_INSTALL_DIR})

=== 3rdparty/ext_aqbanking/CMakeLists.txt ===
ExternalProject_Add(
  ext_aqbanking
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://www.aquamaniac.de/rdm/attachments/download/238/aqbanking-6.0.1.tar.gz
  URL_MD5 a011ff8528e8e31e590d96b8dda3bb78

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} --enable-local-install ${AT_HOST} ${AT_SHARED_ONLY} CPPFLAGS=${AT_CPP_FLAGS} LDFLAGS=${AT_LD_FLAGS}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_gwenhywfar ext_ktoblzcheck ext_xmlsec1 ext_gmp
)

=== 3rdparty/ext_grantlee/CMakeLists.txt ===
ExternalProject_Add(
  ext_grantlee
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://github.com/steveire/grantlee/archive/v5.1.0.zip
  URL_MD5 cf959612f577114ad7c9e3456bc41a62

  CMAKE_ARGS ${CMAKE_GLOBAL_PROFILE}
)

=== 3rdparty/ext_ktoblzcheck/CMakeLists.txt ===
ExternalProject_Add(
  ext_ktoblzcheck
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL http://downloads.sourceforge.net/project/ktoblzcheck/ktoblzcheck-1.49.tar.gz
  URL_MD5 2ea1b01a931eb1e52b0ca0e07cb72435

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} ${AT_SHARED_ONLY}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install
)

=== 3rdparty/ext_opensp/CMakeLists.txt ===
ExternalProject_Add(
  ext_opensp
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL http://downloads.sourceforge.net/project/openjade/opensp/1.5.2/OpenSP-1.5.2.tar.gz
  URL_MD5 670b223c5d12cee40c9137be86b6c39b

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} ${AT_SHARED_ONLY} --disable-doc-build
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install
)

=== 3rdparty/ext_png/CMakeLists.txt ===
ExternalProject_Add( ext_png
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://netcologne.dl.sourceforge.net/project/libpng/libpng16/1.6.35/libpng-1.6.35.tar.xz
  URL_MD5 678b7e696a62a193ed3503b04bf449d6

  CMAKE_ARGS ${CMAKE_GLOBAL_PROFILE}
             -DPNG_TESTS=OFF
)

=== 3rdparty/ext_qt/CMakeLists.txt ===
# qtquickcontrols and qtwebchannel are required by qtwebengine
# "WebRTC" is required by "Pepper Plugins" is required by "Printing and PDF"
# don't use -I and -L switches as they will cause explicit link to
# OpenSSL instead of BoringSSL in QWebEngine
ExternalProject_Add(
  ext_qt
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://download.qt.io/archive/qt/5.11/5.11.3/single/qt-everywhere-src-5.11.3.tar.xz
  URL_MD5 02b353bfe7a40a8dc4274e1d17226d2b

  PATCH_COMMAND ${PATCH_COMMAND} -p1 -i ${CMAKE_CURRENT_SOURCE_DIR}/qsql_mysql.diff

  CONFIGURE_COMMAND <SOURCE_DIR>/configure -prefix ${EXT_INSTALL_DIR} -opensource -confirm-license -verbose -nomake examples -nomake tests -nomake tools ICU_LIBDIR="${EXT_INSTALL_DIR}/lib" ICU_INCDIR="${EXT_INSTALL_DIR}/include" OPENSSL_LIBDIR="${EXT_INSTALL_DIR}/openssl/lib" OPENSSL_INCDIR="${EXT_INSTALL_DIR}/openssl/include" -openssl-linked -skip qt3d -skip qtactiveqt -skip qtcanvas3d -skip qtconnectivity -skip qtenginio -skip qtgraphicaleffects -skip qtlocation -skip qtwayland -skip qtandroidextras -skip qtserialport -skip qtdatavis3d -skip qtvirtualkeyboard -skip qtspeech -skip qtsensors -skip qtgamepad -skip qtscxml -skip qtremoteobjects -skip qtxmlpatterns -skip qtcharts -skip qtdatavis3d -skip qtgamepad -skip qtpurchasing -skip qtscxml -skip qtserialbus -skip qtspeech -skip qtvirtualkeyboard -skip qtdoc -skip qtmacextras -skip qtwinextras -skip qtwebglplugin -skip qtwebsockets -skip qtwebview -skip qtmultimedia -skip qtnetworkauth -skip qtimageformats -system-webengine-icu

  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install
  DEPENDS ext_xslt ext_mysql ext_sqlite ext_postgresql ext_pcre2
)

=== 3rdparty/ext_sharedmimeinfo/CMakeLists.txt ===
ExternalProject_Add(
  ext_sharedmimeinfo
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://people.freedesktop.org/~hadess/shared-mime-info-1.10.tar.xz
  URL_MD5 418c2ced9dc4dd5ca8b06a755e6d64e9

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} ${AT_SHARED_ONLY} ${AUTOMAKE_DEFAULT_HOST} ${AUTOMAKE_SHARED_ONLY} --disable-update-mimedb
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_intltool
)

=== 3rdparty/ext_sqlcipher/CMakeLists.txt ===
ExternalProject_Add(
  ext_sqlcipher
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL https://github.com/sqlcipher/sqlcipher/archive/v3.4.2.zip
  URL_MD5 f12c5975d784856ea89f83cfc9af1a6c

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST} ${AT_SHARED_ONLY} CPPFLAGS=${AT_CPP_FLAGS} LDFLAGS=${AT_LD_FLAGS} --enable-tempstore=yes CFLAGS=-DSQLITE_HAS_CODEC
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_tcl
)

=== 3rdparty/ext_xslt/CMakeLists.txt ===
ExternalProject_Add(
  ext_xslt
  DOWNLOAD_DIR ${EXT_DOWNLOAD_DIR}
  URL http://xmlsoft.org/sources/libxslt-1.1.32.tar.gz
  URL_MD5 1fc72f98e98bf4443f1651165f3aa146

  CONFIGURE_COMMAND <SOURCE_DIR>/configure --prefix=${EXT_INSTALL_DIR} ${AT_HOST}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND $(MAKE) install

  DEPENDS ext_xml
)

=== kmymoney/dialogs/CMakeLists.txt ===
add_subdirectory( settings )

########### next target ###############

set(libdialogs_a_SOURCES
  splitadjustdialog.cpp
  investactivities.cpp
  investtransactioneditor.cpp
  kaccountselectdlg.cpp
  kbackupdlg.cpp
  kbalancewarning.cpp
  kcategoryreassigndlg.cpp
  kchooseimportexportdlg.cpp
  kconfirmmanualenterdlg.cpp
  kcurrencycalculator.cpp
  kcurrencyeditdlg.cpp
  kavailablecurrencydlg.cpp
  kcurrencyeditordlg.cpp
  keditscheduledlg.cpp
  kenterscheduledlg.cpp
  kequitypriceupdatedlg.cpp
  kequitypriceupdateconfdlg.cpp
  kfindtransactiondlg.cpp
  kloadtemplatedlg.cpp
  kmergetransactionsdlg.cpp
  kmymoneyfileinfodlg.cpp
  kmymoneypricedlg.cpp
  kmymoneysplittable.cpp
  knewaccountdlg.cpp
  hierarchyfilterproxymodel.cpp
  knewbankdlg.cpp
  knewequityentrydlg.cpp
  editpersonaldatadlg.cpp
  kpayeereassigndlg.cpp
  ktagreassigndlg.cpp
  kselecttransactionsdlg.cpp
  ksplittransactiondlg.cpp
  ktemplateexportdlg.cpp
  kupdatestockpricedlg.cpp
  transactioneditor.cpp
  stdtransactioneditor.cpp
  transactionmatcher.cpp
  ksaveasquestion.cpp
)

set(dialogs_HEADERS
  splitadjustdialog.h
  investtransactioneditor.h kcurrencycalculator.h transactioneditor.h stdtransactioneditor.h
  )

set(dialogs_UI
  splitadjustdialog.ui
  kaccountselectdlg.ui kbackupdlg.ui
  kcategoryreassigndlg.ui kchooseimportexportdlg.ui
  kconfirmmanualenterdlg.ui
  kcurrencycalculator.ui kcurrencyeditdlg.ui kavailablecurrencydlg.ui kcurrencyeditordlg.ui
  keditscheduledlg.ui
  kenterscheduledlg.ui
  kequitypriceupdatedlg.ui kequitypriceupdateconfdlg.ui
  kfindtransactiondlg.ui
  kloadtemplatedlg.ui
  kmymoneyfileinfodlg.ui kmymoneypricedlg.ui
  knewaccountdlg.ui knewbankdlg.ui
  knewequityentrydlg.ui editpersonaldatadlg.ui kpayeereassigndlg.ui
  ktagreassigndlg.ui
  kselecttransactionsdlg.ui
  ksortoptiondlg.ui ksplitcorrectiondlg.ui ksplittransactiondlg.ui
  ktemplateexportdlg.ui
  kupdatestockpricedlg.ui
  ksaveasquestion.ui
)

ki18n_wrap_ui(libdialogs_a_SOURCES ${dialogs_UI} )

add_library(dialogs STATIC ${libdialogs_a_SOURCES})

target_link_libraries(dialogs
  PUBLIC
    KChart
    KF5::ItemViews
    KF5::I18n
    KF5::TextWidgets
    KF5::Completion
    Qt5::Widgets
    Alkimia::alkimia
    kmm_mymoney
    onlinetask_interfaces
    kmm_widgets
    kmm_utils_platformtools
  PRIVATE
    KF5::KIOGui
)

target_link_libraries(dialogs LINK_PUBLIC
  kmm_widgets
  kmm_mymoney
  onlinetask_interfaces
)


########### install files ###############

install(FILES  ${dialogs_HEADERS}
  DESTINATION ${INCLUDE_INSTALL_DIR}/kmymoney COMPONENT Devel)

=== debian/changelog ===
kmymoney (5.0.8-1build3) focal; urgency=medium

  * No-change rebuild against KDE PIM 19.12.3

 -- Rik Mills <rikmills@kde.org>  Sat, 11 Apr 2020 21:35:22 +0100

kmymoney (5.0.8-1build2) focal; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-8.

 -- Rik Mills <rikmills@kde.org>  Fri, 10 Apr 2020 20:02:09 +0100

kmymoney (5.0.8-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:16:11 +0100

kmymoney (5.0.8-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump libaqbanking-dev to 6.0.1
    - bump libgwenhywfar-core-dev, and libgwengui-qt5-dev to 5.1.2
  * Bump Standards-Version to 4.5.0, no changes required.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Enable all the variations for reprotest in the salsa CI.

 -- Pino Toscano <pino@debian.org>  Sat, 25 Jan 2020 08:07:32 +0100

kmymoney (5.0.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - requires AqBanking 6 (Closes: #942417)
  * Update the build dependencies according to the upstream build system:
    - bump libaqbanking-dev to 5.99.32
    - bump libgwenhywfar-core-dev, and libgwengui-qt5-dev to 4.99.16
    - explicitly add gettext
  * Bump Standards-Version to 4.4.1, no changes required.
  * Add the configuration for the CI on salsa.
  * Remove changelog entry for binNMU (not needed).

 -- Pino Toscano <pino@debian.org>  Mon, 04 Nov 2019 06:47:57 +0100

=== debian/control ===
Source: kmymoney
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, pkg-kde-tools (>= 0.15.16),
 gettext,
 extra-cmake-modules,
 qtbase5-dev,
 qtbase5-private-dev,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 libkf5activities-dev,
 libkf5akonadi-dev,
 libkf5archive-dev,
 libkf5completion-dev,
 libkf5config-dev,
 libkf5configwidgets-dev,
 libkf5contacts-dev,
 libkf5coreaddons-dev,
 libkf5doctools-dev,
 libkf5holidays-dev,
 libkf5i18n-dev,
 libkf5iconthemes-dev,
 libkf5identitymanagement-dev,
 libkf5itemmodels-dev,
 libkf5itemviews-dev,
 libkchart-dev,
 libkf5kcmutils-dev,
 libkf5kio-dev,
 libkf5notifications-dev,
 libkf5service-dev,
 libkf5textwidgets-dev,
 libkf5wallet-dev,
 libkf5webkit-dev,
 libkf5xmlgui-dev,
 libaqbanking-dev (>= 6.0.1~),
 libgwenhywfar-core-dev (>= 5.1.2~), libgwengui-qt5-dev (>= 5.1.2~),
 libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
 libalkimia5-dev (>= 7.0),
 libical-dev, libofx-dev, libgmp-dev,
 libsqlcipher-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.5.0
Homepage: https://kmymoney.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git

Package: kmymoney
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${aqbanking:Depends}, kmymoney-common (= ${source:Version})
Recommends: gnupg-agent, pinentry-qt | pinentry-x11
Suggests: kcalc
Description: personal finance manager for KDE
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.

Package: kmymoney-common
Architecture: all
Depends: ${misc:Depends},
 ${perl:Depends},
Recommends: kmymoney,
 libfinance-quote-perl,
Description: KMyMoney architecture independent files
 KMyMoney is the Personal Finance Manager for KDE. It operates similar to
 MS-Money and Quicken, supports different account types, categorisation of
 expenses, QIF import/export, multiple currencies and initial online banking
 support.
 .
 This package contains architecture independent files needed for KMyMoney to
 run properly. It also provides KMyMoney documentation. Therefore, unless you
 have 'kmymoney' package installed, you will hardly find this package useful.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with kf5,aqbanking

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DCMAKE_SKIP_RPATH=ON -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove development stuff
	rm -rf debian/tmp/usr/include/
	find debian/tmp -name '*.so' -type l -delete

override_dh_missing:
	dh_missing --fail-missing

.PHONY: override_dh_auto_test

## kmymoney 5.1.0

=== debian/changelog ===
kmymoney (5.1.0-1) unstable; urgency=medium

  * Team upload.

  [ Micha Lenk ]
  * debian/rules: Stop using aqbanking sequence in debhelper. Due to some
    package re-organization introduced in libaqbanking 4.99.40beta-1 this
    debhelper extension isn't needed anymore.

  [ Pino Toscano ]
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump extra-cmake-modules to 5.42.0
    - set Qt packages to 5.2.0
    - set KF packages to 5.42.0
  * Add Rules-Requires-Root: no.

 -- Pino Toscano <pino@debian.org>  Mon, 15 Jun 2020 10:12:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,35 +5,35 @@
 Uploaders: Mark Purcell <msp@debian.org>
 Build-Depends: debhelper-compat (= 12), cmake, pkg-kde-tools (>= 0.15.16),
  gettext,
- extra-cmake-modules,
- qtbase5-dev,
- qtbase5-private-dev,
- qtdeclarative5-dev,
- libqt5svg5-dev,
- libkf5activities-dev,
+ extra-cmake-modules (>= 5.42.0~),
+ qtbase5-dev (>= 5.2.0~),
+ qtbase5-private-dev (>= 5.2.0~),
+ qtdeclarative5-dev (>= 5.2.0~),
+ libqt5svg5-dev (>= 5.2.0~),
+ libkf5activities-dev (>= 5.2.0~),
  libkf5akonadi-dev,
- libkf5archive-dev,
- libkf5completion-dev,
- libkf5config-dev,
- libkf5configwidgets-dev,
+ libkf5archive-dev (>= 5.2.0~),
+ libkf5completion-dev (>= 5.2.0~),
+ libkf5config-dev (>= 5.2.0~),
+ libkf5configwidgets-dev (>= 5.2.0~),
  libkf5contacts-dev,
- libkf5coreaddons-dev,
- libkf5doctools-dev,
+ libkf5coreaddons-dev (>= 5.2.0~),
+ libkf5doctools-dev (>= 5.2.0~),
  libkf5holidays-dev,
- libkf5i18n-dev,
- libkf5iconthemes-dev,
+ libkf5i18n-dev (>= 5.2.0~),
+ libkf5iconthemes-dev (>= 5.2.0~),
  libkf5identitymanagement-dev,
- libkf5itemmodels-dev,
- libkf5itemviews-dev,
+ libkf5itemmodels-dev (>= 5.2.0~),
+ libkf5itemviews-dev (>= 5.2.0~),
  libkchart-dev,
- libkf5kcmutils-dev,
- libkf5kio-dev,
- libkf5notifications-dev,
- libkf5service-dev,
- libkf5textwidgets-dev,
- libkf5wallet-dev,
- libkf5webkit-dev,
- libkf5xmlgui-dev,
+ libkf5kcmutils-dev (>= 5.2.0~),
+ libkf5kio-dev (>= 5.2.0~),
+ libkf5notifications-dev (>= 5.2.0~),
+ libkf5service-dev (>= 5.2.0~),
+ libkf5textwidgets-dev (>= 5.2.0~),
+ libkf5wallet-dev (>= 5.2.0~),
+ libkf5webkit-dev (>= 5.2.0~),
+ libkf5xmlgui-dev (>= 5.2.0~),
  libaqbanking-dev (>= 6.0.1~),
  libgwenhywfar-core-dev (>= 5.1.2~), libgwengui-qt5-dev (>= 5.1.2~),
  libgpgmepp-dev, libgpg-error-dev, libgpgme-dev,
@@ -43,13 +43,14 @@
  libsqlite3-dev,
  pkg-config,
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://kmymoney.org/
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kmymoney
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kmymoney.git
 
 Package: kmymoney
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${aqbanking:Depends}, kmymoney-common (= ${source:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, kmymoney-common (= ${source:Version})
 Recommends: gnupg-agent, pinentry-qt | pinentry-x11
 Suggests: kcalc
 Description: personal finance manager for KDE

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 %:
-	dh $@ --with kf5,aqbanking
+	dh $@ --with kf5
 
 override_dh_auto_configure:
 	dh_auto_configure -Skf5 -- -DCMAKE_SKIP_RPATH=ON -DBUILD_TESTING=OFF
